function PCI1202

%--------------------------------------------------------- 
%A823 MatLab Library for PCI1202 Data Acquisition Board
%---------------------------------------------------------
%
%     (C) Dr. Juan Antonio Fernandez Madrigal, 2005
%                  Vicente Arevalo Espejo, 2005
%
%           System Engineering and Automation Dpt.
%               University of Malaga (Spain)
%              www.isa.uma.es/personal/jafma
%
%
%This library provides access to high-level functionality of
%the PCI1202 acquisition board.
%
%Currently, the following functions are available:
%
% PCI1202_InitDriverAndBoard - initiates the driver and the 
%                           first board encountered
% PCI1202_CloseDriverAndBoard - finishes accesses to the board
% PCI1202_ErrorText - gets the description of an error code of 
%                  the driver
% PCI1202_Delay - performs hardware short delays
% PCI1202_SendDA - sends digital data through the digital/analogic 
%               channels
% PCI1202_ReadAD - reads digital data from the analogic/digital 
%               channels
% PCI1202_SendAndRead - simoultaneously sends and reads data 
%		    	   to/from analogic channels
% PCI1202_PID - implements a PID controller
%
%For more information on any function, type "help <function name>"
%