function a=PCI1202_SendAndRead(b,c,d,e,f,g)

% A=PCI1202_SendAndRead(B,C,D,E,F,G)
%
% Simoultaneously sends and reads to/from analogic channels.
%
% Inputs:
%   B=   input A/D channel number for reading (0 to 31)
%   C=   quantification window code (see help of PCI1202_ReadAD)
%   D=   type of PCI1202 board for reading (see help of PCI1202_ReadAD)
%   E=   output D/A channel number for sending (0,1)
%   F=   vector of values to send (each one from 0 to 4095)
%
% Outputs:
%   A=  row vector with the digital data read (values within -10 to 10)
%	  concatenated with clock information. If length(F)=m, the format of A is:
%
%		a(1:m) -> one read voltage for each sample
%		a(m+(1:m)) -> one clock value for the corresponding sample.
%				The clock is a value indicating real-time, in seconds, beginning with 0.0.
%       a(2*m+1) -> number of ticks per second used for computing the clock
%               values (gives an idea of the precision of the timing).
%
